/*
 * Copyright (c) 2005 Pramati Technologies Private Ltd. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Pramati
 * Technologies. You shall not disclose such Confidential Information and shall
 * use it only in accordance with the terms of the source code
 * license agreement you entered into with Pramati Technologies.
 *
 */
package test;

import javax.persistence.*;
import java.util.Set;
import java.util.HashSet;

/**
 * @author <a href="mailto:jiteshmehta@pramati.com">Jitesh Mehta</a>
 * @version $Revision$, $Date$, $Author$
 * @since Oct 13, 2006
 */

@Entity
@Table(name = "TABLE_A")
@NamedQuery(name = "A.findAllA", query = "SELECT a FROM A a")
public class A {

    private int id;
    private Set<B> b;
    private String name;

    public A() {

    }

    public A(String name) {
        this.b = new HashSet<B>();
        this.name = name;
    }


    @Id
            @Basic
            @GeneratedValue

            public int getId() {
        return id;
    }

    @ManyToMany(fetch = FetchType.LAZY)
            @JoinTable(name = "A_B_TABLE",
            joinColumns =
            @JoinColumn(name = "A_ID", referencedColumnName = "ID"),
            inverseJoinColumns =
            @JoinColumn(name = "B_NAME", referencedColumnName = "NAME"))

            public Set<B> getB() {
        return b;
    }

    public void setB(Set<B> b) {
        this.b = b;
    }

    @Basic
            public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setId(int id) {
        this.id = id;
    }

    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof A)) return false;

        final A a = (A) o;

        if (id != a.id) return false;

        return true;
    }

    public int hashCode() {
        return id;
    }

    public String toString() {
        return A.class.getName()+" id :"+id;
    }
}
