/*
 * Copyright (c) 2005 Pramati Technologies Private Ltd. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Pramati
 * Technologies. You shall not disclose such Confidential Information and shall
 * use it only in accordance with the terms of the source code
 * license agreement you entered into with Pramati Technologies.
 *
 */
package test;

import javax.persistence.*;
import java.util.Set;
import java.util.HashSet;

/**
 * @author <a href="mailto:jiteshmehta@pramati.com">Jitesh Mehta</a>
 * @version $Revision$, $Date$, $Author$
 * @since Oct 13, 2006
 */

@Entity
@Table(name = "TABLE_B")
@NamedQueries({
    @NamedQuery(name = "B.findAllB",
                query = "SELECT b FROM B b"
    ),
    @NamedQuery(name = "B.findByB",
                query = "SELECT o FROM B o WHERE o.name=:b"/*,  hints = @QueryHint(name="toplink.refresh", value="true")*/
    )
    })
public class B {


    private Set<A> a;

    private String name;

    public B() {

    }

    public B(String name) {
        this();
        this.name = name;
        a = new HashSet<A>();
    }

    @Id
            @Basic
    String getName() {
        return name;
    }

    @ManyToMany(mappedBy = "b")
            public Set<A> getA() {
        return a;
    }

    public void setA(Set<A> a) {
        this.a = a;
    }

    public void setName(String name) {
        this.name = name;
    }

    public static B getOrCreateB(EntityManager em, String b_name, A a) {
        Object singleResult = null;
        try {
            singleResult = em.createNamedQuery("B.findByB").setParameter("b", b_name.trim()).getSingleResult();
            return (B) singleResult;
        } catch (NoResultException e) {
            B b = new B(b_name);
//            tag1.getDigitalObjects().add(digitalObject);
//            em.getTransaction().begin();
            em.persist(b);
//            em.getTransaction().commit();
            return b;
        }
    }
}
